/************************************************************************
 *									*
 *		VurdVXe@ob|bmrvO		*
 *									*
 *				: [JR}h			*
 *		t@C	: local.c				*
 *		쐬		: 91/04/01				*
 *									*
 ************************************************************************/

#include "pc_cns.h"

/*	[JR}h	*/
#define	LOC_CSG		0x10
#define	LOC_CSG_NSG	0x11
#define	LOC_CSG_FSG	0x12
#define	LOC_CSG_COL	0x13
#define	LOC_CSG_LRM	0x14
#define	LOC_CSG_OPT	0x15
#define	LOC_SSG		0x20
#define	LOC_SSG_CON	0x21
#define	LOC_SSG_NSG	0x22
#define	LOC_SSG_SYC	0x23
#define	LOC_SSG_ANM	0x24
#define	LOC_SSG_CRM	0x25
#define	LOC_SSG_CMF	0x26
#define	LOC_SSG_AEC	0x27
#define	LOC_DSP		0x30
#define	LOC_DSP_CSG	0x31
#define	LOC_DSP_SSG	0x32
#define	LOC_CSC		0x40
#define	LOC_CSC_CCQ	0x41
#define	LOC_CSC_DOS	0x42
#define	LOC_CSC_END	0x43
#define	LOC_UTL		0x50
#define	LOC_UTL_CPY	0x51
#define	LOC_UTL_CFG	0x52
#define	LOC_UTL_CFD	0x53
#define	LOC_UTL_MTR	0x54

/*	p[^e[u	*/
static	char	*csg_col[] = {	/* \F */
	"",		/* 0  */
	"B",		/* 1  */
	"R",		/* 2  */
	"P",		/* 3  */
	"G",		/* 4  */
	"LB",		/* 5 F */
	"Y",		/* 6  */
	"W",		/* 7  */
	NULL
};
static	char	*csg_lrm1[] = {	/* ʕ\ */
	"",		/* 0  */
	"DSP",		/* 1 ʕ\L */
	NULL
};
static	char	*csg_lrm2[] = {	/* v^o */
	"",		/* 0  */
	"PRN",		/* 1 L */
	NULL
};
static	char	*csg_lrm3[] = {	/* t@Co */
	"",		/* 0 o͖ */
	"FIL",		/* 1 { */
	NULL
};
static	char	*csg_opt1[] = {	/* RS-232Cx */
	"9600",		/* 0 9600 */
	"4800",		/* 1 4800 */
	"2400",		/* 2 2400 */
	"1200",		/* 3 1200 */
	NULL
};
static	char	*csg_opt2[] = {	/* v^[̋@w */
	"201",		/* 0 mdb@ob|oqQOP */
	"602",		/* 1 mdb@ob|oqUOQ */
	"NM",		/* 2 mdb@mlV[Y */
	"xxxxx",	/* 3 dornm */
	NULL
};
static	char	*csg_opt3[] = {	/* َ̧sװ */
	"",		/* 0  */
	"STP",		/* 1 ~ */
	NULL
};
static	char	*csg_opt4[] = { /* Rg̎} */
	"",		/* 0 } */
	"INS",		/* 1 } */
	NULL
};
static	char	*ssg_anm1[] = {	/* ʕ\ */
	"",		/* 0  */
	"DSP",		/* 1 ʕ\L */
	NULL
};
static	char	*ssg_anm2[] = {	/* v^o */
	"",		/* 0  */
	"PRN",		/* 1 L */
	NULL
};
static	char	*ssg_anm3[] = {	/* t@Co */
	"",		/* 0 o͖ */
	"FIL",		/* 1 { */
	"FIC",		/* 2 ԍ */
	NULL
};
static	char	*ssg_crm1[] = {	/* ʕ\ */
	"",		/* 0  */
	"DSP",		/* 1 ʕ\L */
	NULL
};
static	char	*ssg_crm2[] = {	/* v^o */
	"",		/* 0  */
	"PRN",		/* 1 L */
	NULL
};
static	char	*ssg_crm3[] = {	/* t@Co */
	"",		/* 0 o͖ */
	"FIL",		/* 1 { */
	"FIC",		/* 2 ԍ */
	NULL
};
static	char	*utl_cfd[] = {	/* R}ht@C */
	"DSP",		/* 0 \ */
	"UPD",		/* 1 C */
	"DEL",		/* 2 폜 */
	NULL
};
static	char	*utl_mtr1[] = {	/* bZ[W */
	"ANM",		/* 0 bZ[W */
	"CRM",		/* 1 R}hbZ[W */
	NULL
};
static	char	*utl_mtr2[] = {	/* ʕ\ */
	"",		/* 0  */
	"DSP",		/* 1 ʕ\L */
	NULL
};
static	char	*utl_mtr3[] = {	/* v^o */
	"",		/* 0  */
	"PRN",		/* 1 L */
	NULL
};
static	char	*utl_mtr4[] = {	/* t@Co */
	"",		/* 0 o͖ */
	"FIL",		/* 1 { */
	NULL
};

/*	X^eBbNϐ	*/
static	char	*cmbp;		/* R}h|C^ */
static	char	cmd_name[4];	/* R}hiށj */
static	char	prm_name[4];	/* p[^iށj */

/*	֐	*/
static	int	exec_csg_nsg(void);
static	int	exec_csg_fsg(void);
static	int	exec_csg_col(void);
static	int	exec_csg_lrm(void);
static	int	exec_csg_opt(void);
static	int	exec_ssg_con(void);
static	int	exec_ssg_nsg(void);
static	int	exec_ssg_syc(void);
static	int	exec_ssg_anm(void);
static	int	exec_ssg_crm(void);
static	int	exec_ssg_cmf(void);
static	int	exec_ssg_aec(void);
static	int	exec_dsp_csg(void);
static	void	exec_dsp_csg_nsg(PRT_TBL *);
static	void	exec_dsp_csg_fsg(PRT_TBL *);
static	void	exec_dsp_csg_col(PRT_TBL *);
static	void	exec_dsp_csg_lrm(PRT_TBL *);
static	void	exec_dsp_csg_opt(PRT_TBL *);
static	int	exec_dsp_ssg(void);
static	void	exec_dsp_ssg_nsg(PRT_TBL *);
static	void	exec_dsp_ssg_syc(PRT_TBL *);
static	void	exec_dsp_ssg_anm(PRT_TBL *);
static	void	exec_dsp_ssg_crm(PRT_TBL *);
static	void	exec_dsp_ssg_cmf(PRT_TBL *);
static	void	exec_dsp_ssg_aec(PRT_TBL *);
static	void	dspsel(PRT_TBL *, char *);
static	void	dspnum(PRT_TBL *, int);
static	void	dspnam(PRT_TBL *, char *);
static	int	exec_csc_ccq(void);
static	int	exec_csc_dos(void);
static	int	exec_csc_end(void);
static	int	exec_utl_cpy(void);
static	int	exec_utl_cfg(void);
static	int	exec_utl_cfd(void);
static	int	exec_utl_mtr(void);
static	int	getsel(char *, char **);
static	char	*getprm(void);
static	void	setsel(char *);
static	void	setnum(int);
static	void	setnam(char *);
static	int	chk_loc_cmd(void);

/*=======================================================================
 |
 |		[JR}hs
 |
 |	int	exec_local(buf)
 |
 |		char	*buf;		R}hobt@
 |
 =======================================================================*/
int	exec_local(char *buf)
{
	int	msg_no;		/* bZ[Wm. */

	cmbp = buf;
	switch (chk_loc_cmd()) {
	case LOC_CSG_NSG:	/* R\[rft@C */
		msg_no = exec_csg_nsg();
		break;
	case LOC_CSG_FSG:	/* R}hAbZ[Wt@CƂ̌ */
		msg_no = exec_csg_fsg();
		break;
	case LOC_CSG_COL:	/* ʂ̐Fw */
		msg_no = exec_csg_col();
		break;
	case LOC_CSG_LRM:	/* ۰ٺމүނ̏o͋@̐ݒ */
		msg_no = exec_csg_lrm();
		break;
	case LOC_CSG_OPT:	/* IvVݒ */
		msg_no = exec_csg_opt();
		break;
	case LOC_SSG_CON:	/* ȸݔԍɂ輽тrf̧قI */
		msg_no = exec_ssg_con();
		break;
	case LOC_SSG_NSG:	/* VXerft@C쐬ύX */
		msg_no = exec_ssg_nsg();
		break;
	case LOC_SSG_SYC:	/* VXe萔 */
		msg_no = exec_ssg_syc();
		break;
	case LOC_SSG_ANM:	/* bZ[W̏o͋@̐ݒ */
		msg_no = exec_ssg_anm();
		break;
	case LOC_SSG_CRM:	/* މbZ[W̏o͋@̐ݒ */
		msg_no = exec_ssg_crm();
		break;
	case LOC_SSG_CMF:	/* R}ht@Cǂ݂pX */
		msg_no = exec_ssg_cmf();
		break;
	case LOC_SSG_AEC:	/* 莞NR}h̐ݒ */
		msg_no = exec_ssg_aec();
		break;
	case LOC_DSP_CSG:	/* brf֌W̕\s */
		msg_no = exec_dsp_csg();
		break;
	case LOC_DSP_SSG:	/* rrf֌W̕\s */
		msg_no = exec_dsp_ssg();
		break;
	case LOC_CSC_CCQ:	/* R}hRlNVؒf */
		msg_no = exec_csc_ccq();
		break;
	case LOC_CSC_DOS:	/* cnrɐn */
		msg_no = exec_csc_dos();
		break;
	case LOC_CSC_END:	/* VXeI */
		msg_no = exec_csc_end();
		break;
	case LOC_UTL_CPY:	/* t@CPʂ̃Rs[s */
		msg_no = exec_utl_cpy();
		break;
	case LOC_UTL_CFG:	/* R}ht@C쐬 */
		msg_no = exec_utl_cfg();
		break;
	case LOC_UTL_CFD:	/* R}ht@C\^C^폜 */
		msg_no = exec_utl_cfd();
		break;
	case LOC_UTL_MTR:	/* ү̧ق{ϊo͂ */
		msg_no = exec_utl_mtr();
		break;
	default:
		msg_no = LOC_MSG_ERPRM;
		break;
	}

	/* IbZ[W\ */
	dsp_loc_msg(msg_no, cmd_name, prm_name);

	return(msg_no == LOC_MSG_NORMAL ? 0 : 1);
}

/*=======================================================================
 |
 |		brf@mrfR}hs
 |
 |	int	exec_csg_nsg()
 |
 =======================================================================*/
static	int	exec_csg_nsg()
{
	char	*p;			/* p[^|C^ */
	char	sys_name[9];		/* VXe */
	char	grf_file[SZ_PATH];	/* Gʃt@C */
	char	online_id;		/* IChc */
	char	offline_id;		/* ItChc */

	/* IC`FbN */
	if (online)
		return(LOC_MSG_ERCON);

	/* Ŝ̃VXeo */
	p = getprm();
	if (strlen(p) > 8)
		return(LOC_MSG_ERLEN);
	strcpy(sys_name, p);

	/* Gʃt@Co */
	p = getprm();
	if (strlen(p) > SZ_PATH)
		return(LOC_MSG_ERLEN);
	strcpy(grf_file, p);

	/* R}hhciICjo */
	p = getprm();
	if (strlen(p) > 1)
		return(LOC_MSG_ERLEN);
	if (*p != '\\' && *p != '$' && *p != '#' && *p != '%')
		return(LOC_MSG_ERPRM);
	online_id =  *p;

	/* R}hhciItCjo */
	p = getprm();
	if (strlen(p) > 1)
		return(LOC_MSG_ERLEN);
	if (*p != '\\' && *p != '$' && *p != '#' && *p != '%')
		return(LOC_MSG_ERPRM);
	offline_id =  *p;

	/* p[^I`FbN */
	if (*cmbp != '/')
		return(LOC_MSG_ERPRM);

	/* R\[rff[^Zbg */
	strcpy(csg.nsg.sys_name, sys_name);
	strcpy(csg.nsg.grf_file, grf_file);
	csg.nsg.online_id = online_id;
	csg.nsg.offline_id = offline_id;

	/* R\[rft@Cݒ */
	sprintf(csg_file, "%s.CSG", sys_name);

	/* R\[rft@Cɏ */
	write_csg();

	return(LOC_MSG_NORMAL);
}

/*=======================================================================
 |
 |		brf@erfR}hs
 |
 |	int	exec_csg_fsg()
 |
 =======================================================================*/
static	int	exec_csg_fsg()
{
	char	*p;			/* p[^|C^ */
	int	i;			/* [vJE^ */
	char	amsg_file[13];		/* bZ[Wt@C */
	char	cms_file[5][13];	/* R}hIt@C */
	char	cmsg_file[13];		/* R}hbZ[Wt@C */
	char	loc_file[13];		/* [JR}hIt@C */
	char	lmsg_file[13];		/* ۰ٺމbZ[Wt@C */

	/* IC`FbN */
	if (online)
		return(LOC_MSG_ERCON);

	/* bZ[Wt@Co */
	p = getprm();
	if (strlen(p) > 12)
		return(LOC_MSG_ERLEN);
	strcpy(amsg_file, p);

	/* R}hIt@Co */
	for (i = 0; i < 5; i++) {
		p = getprm();
		if (strlen(p) > 12)
			return(LOC_MSG_ERLEN);
		strcpy(cms_file[i], p);
	}

	/* R}hbZ[Wt@Co */
	p = getprm();
	if (strlen(p) > 12)
		return(LOC_MSG_ERLEN);
	strcpy(cmsg_file, p);

	/* [JR}hIt@Co */
	p = getprm();
	if (strlen(p) > 12)
		return(LOC_MSG_ERLEN);
	strcpy(loc_file, p);

	/* ۰ٺމbZ[Wt@Co */
	p = getprm();
	if (strlen(p) > 12)
		return(LOC_MSG_ERLEN);
	strcpy(lmsg_file, p);

	/* p[^I`FbN */
	if (*cmbp != '/')
		return(LOC_MSG_ERPRM);

	/* R\[rff[^Zbg */
	strcpy(csg.fsg.amsg_file, amsg_file);
	for (i = 0; i < 5; i++)
		strcpy(csg.fsg.cms_file[i], cms_file[i]);
	strcpy(csg.fsg.cmsg_file, cmsg_file);
	strcpy(csg.fsg.loc_file, loc_file);
	strcpy(csg.fsg.lmsg_file, lmsg_file);

	/* R\[rft@Cɏ */
	write_csg();

	return(LOC_MSG_NORMAL);
}

/*=======================================================================
 |
 |		brf@bnkR}hs
 |
 |	int	exec_csg_col()
 |
 =======================================================================*/
static	int	exec_csg_col()
{
	char	*p;		/* p[^|C^ */
	int	i;		/* [vJE^ */
	int	col[9];		/* \F */

	/* ʂ̐Fo */
	for (i = 0; i < 9; i++) {
		p = getprm();
		if ((col[i] = getsel(p, csg_col)) == -1)
			return(LOC_MSG_ERPRM);
	}

	/* p[^I`FbN */
	if (*cmbp != '/')
		return(LOC_MSG_ERPRM);

	/* R\[rff[^Zbg */
	memcpy(&csg.col, col, sizeof(csg.col));

	/* R\[rft@Cɏ */
	write_csg();

	return(LOC_MSG_NORMAL);
}

/*=======================================================================
 |
 |		brf@kqlR}hs
 |
 |	int	exec_csg_lrm()
 |
 =======================================================================*/
static	int	exec_csg_lrm()
{
	char	*p;		/* p[^|C^ */
	int	dsp;		/* ʕ\L^ */
	int	prn;		/* v^o͗L^ */
	int	fil;		/* t@Co͗L^ */
	char	fname[SZ_PATH];	/* t@Co͗L莞̃t@C */

	/* ʕ\L^o */
	p = getprm();
	if ((dsp = getsel(p, csg_lrm1)) == -1)
		return(LOC_MSG_ERPRM);

	/* v^o͗L^o */
	p = getprm();
	if ((prn = getsel(p, csg_lrm2)) == -1)
		return(LOC_MSG_ERPRM);

	/* t@Co͗L^o */
	p = getprm();
	if ((fil = getsel(p, csg_lrm3)) == -1)
		return(LOC_MSG_ERPRM);

	/* t@Co͗L莞̃t@Co */
	p = getprm();
	if (strlen(p) > SZ_PATH)
		return(LOC_MSG_ERLEN);
	strcpy(fname, p);

	/* t@C̓`FbN */
	if (fil != 0) {
		if (*p == '\0')
			return(LOC_MSG_ERFILE);
	}

	/* gq`FbN */
	if (*p != '\0') {
		if ((p = strchr(p, '.')) == NULL || strcmp(p, ".MSL") != 0)
			return(LOC_MSG_EREXT);
	}

	/* p[^I`FbN */
	if (*cmbp != '/')
		return(LOC_MSG_ERPRM);

	/* R\[rff[^Zbg */
	csg.lrm.dsp = dsp;
	csg.lrm.prn = prn;
	csg.lrm.fil = fil;
	strcpy(csg.lrm.fname, fname);

	/* R\[rft@Cɏ */
	write_csg();

	return(LOC_MSG_NORMAL);
}

/*=======================================================================
 |
 |		brf@nosR}hs
 |
 |	int	exec_csg_opt()
 |
 =======================================================================*/
static	int	exec_csg_opt()
{
	char	*p;		/* p[^|C^ */
	int	rs232c;		/* qrQRQbx */
	int	printer;	/* v^[@ */
	int	cmd_to;		/* R}h̓^CAEg */
	int	cmd_err;	/* R}ht@CsG[u */
	int	comment;	/* Rg̎} */

	/* qrQRQbxo */
	p = getprm();
	if ((rs232c = getsel(p, csg_opt1)) == -1)
		return(LOC_MSG_ERPRM);

	/* v^[@o */
	p = getprm();
	if ((printer = getsel(p, csg_opt2)) == -1)
		return(LOC_MSG_ERPRM);

	/* R}h̓^CAEgԎo */
	p = getprm();
	cmd_to = atoi(p);

	/* R}ht@CsG[uo */
	p = getprm();
	if ((cmd_err = getsel(p, csg_opt3)) == -1)
		return(LOC_MSG_ERPRM);

	/* Rg̎}o */
	p = getprm();
	if ((comment = getsel(p, csg_opt4)) == -1)
		return(LOC_MSG_ERPRM);

	/* p[^I`FbN */
	if (*cmbp != '/')
		return(LOC_MSG_ERPRM);

	/* R\[rff[^Zbg */
	csg.opt.rs232c = rs232c;
	csg.opt.printer = printer;
	csg.opt.cmd_to = cmd_to;
	csg.opt.cmd_err = cmd_err;
	csg.opt.comment = comment;

	/* R\[rft@Cɏ */
	write_csg();

	return(LOC_MSG_NORMAL);
}

/*=======================================================================
 |
 |		rrf@bnmR}hs
 |
 |	int	exec_ssg_con()
 |
 =======================================================================*/
static	int	exec_ssg_con()
{
	char	*p;		/* p[^|C^ */
	int	conxxxtion;	/* RlNVԍ */

	/* IC`FbN */
	if (online)
		return(LOC_MSG_ERCON);

	/* RlNVԍo */
	p = getprm();
	if (*p == '\0' || (conxxxtion = atoi(p)) > 63)
		return(LOC_MSG_ERPRM);

	/* p[^I`FbN */
	if (*cmbp != '/')
		return(LOC_MSG_ERPRM);

	/* VXerft@Cݒ */
	if (find_ssg(conxxxtion) == 0)
		read_ssg();

	return(LOC_MSG_NORMAL);
}

/*=======================================================================
 |
 |		rrf@mrfR}hs
 |
 |	int	exec_ssg_nsg()
 |
 =======================================================================*/
static	int	exec_ssg_nsg()
{
	char	*p;			/* p[^|C^ */
	char	sys_name[7];		/* ʃVXe */
	char	grf_file[SZ_PATH];	/* Gʃt@C */
	int	conxxxtion;		/* RlNVԍ */
	int	kanshi;			/* Ď */

	/* IC`FbN */
	if (online)
		return(LOC_MSG_ERCON);

	/* ʃVXeo */
	p = getprm();
	if (strlen(p) > 6)
		return(LOC_MSG_ERLEN);
	strcpy(sys_name, p);

	/* Gʃt@Co */
	p = getprm();
	if (strlen(p) > SZ_PATH)
		return(LOC_MSG_ERLEN);
	strcpy(grf_file, p);

	/* RlNVԍo */
	p = getprm();
	if ((conxxxtion = atoi(p)) > 63)
		return(LOC_MSG_ERPRM);

	/* Ďo */
	p = getprm();
	kanshi = atoi(p);

	/* p[^I`FbN */
	if (*cmbp != '/')
		return(LOC_MSG_ERPRM);

	/* VXerff[^Zbg */
	strcpy(ssg.nsg.sys_name, sys_name);
	strcpy(ssg.nsg.grf_file, grf_file);
	ssg.nsg.conxxxtion = conxxxtion;
	ssg.nsg.kanshi = kanshi;

	/* VXerft@Cݒ */
	sprintf(ssg_file, "%s%02d.SSG", sys_name, conxxxtion);

	/* VXerft@Cɏ */
	write_ssg();

	return(LOC_MSG_NORMAL);
}

/*=======================================================================
 |
 |		rrf@rxbR}hs
 |
 |	int	exec_ssg_syc()
 |
 =======================================================================*/
static	int	exec_ssg_syc()
{
	char	*p;			/* p[^|C^ */
	int	i;			/* [vJE^ */
	struct	{
		int	syc_flg;	/* VXe萔wtO */
		int	syc_val;	/* VXe萔 */
	} syc[10];

	/* VXe萔o */
	for (i = 0; i < 10; i++) {
		p = getprm();
		if (*p != '\0') {
			syc[i].syc_flg = 1;
			syc[i].syc_val = atoi(p);
		} else
			syc[i].syc_flg = 0;
	}

	/* p[^I`FbN */
	if (*cmbp != '/')
		return(LOC_MSG_ERPRM);

	/* VXerff[^Zbg */
	memcpy(ssg.syc, syc, sizeof(syc));

	/* VXerft@Cɏ */
	write_ssg();

	return(LOC_MSG_NORMAL);
}

/*=======================================================================
 |
 |		rrf@`mlR}hs
 |
 |	int	exec_ssg_anm()
 |
 =======================================================================*/
static	int	exec_ssg_anm()
{
	char	*p;		/* p[^|C^ */
	int	dsp;		/* ʕ\L^ */
	int	prn;		/* v^o͗L^ */
	int	fil;		/* t@Co͗L^ */
	char	fname[SZ_PATH];	/* t@Co͗L莞̃t@C */

	/* ʕ\L^o */
	p = getprm();
	if ((dsp = getsel(p, ssg_anm1)) == -1)
		return(LOC_MSG_ERPRM);

	/* v^o͗L^o */
	p = getprm();
	if ((prn = getsel(p, ssg_anm2)) == -1)
		return(LOC_MSG_ERPRM);

	/* t@Co͗L^o */
	p = getprm();
	if ((fil = getsel(p, ssg_anm3)) == -1)
		return(LOC_MSG_ERPRM);

	/* t@Co͗L莞̃t@Co */
	p = getprm();
	if (strlen(p) > SZ_PATH)
		return(LOC_MSG_ERPRM);
	strcpy(fname, p);

	/* t@C̓`FbN */
	if (fil != 0) {
		if (*p == '\0')
			return(LOC_MSG_ERFILE);
	}

	/* gq`FbN */
	if (*p != '\0') {
		if ((p = strchr(p, '.')) == NULL)
			return(LOC_MSG_EREXT);
		if (fil == 1) {
			if (strcmp(p, ".MSL") != 0)
				return(LOC_MSG_EREXT);
		} else if (fil == 2) {
			if (strcmp(p, ".MSC") != 0)
				return(LOC_MSG_EREXT);
		}
	}

	/* p[^I`FbN */
	if (*cmbp != '/')
		return(LOC_MSG_ERPRM);

	/* VXerff[^Zbg */
	ssg.anm.dsp = dsp;
	ssg.anm.prn = prn;
	ssg.anm.fil = fil;
	strcpy(ssg.anm.fname, fname);

	/* VXerft@Cɏ */
	write_ssg();

	return(LOC_MSG_NORMAL);
}

/*=======================================================================
 |
 |		rrf@bqlR}hs
 |
 |	int	exec_ssg_crm()
 |
 =======================================================================*/
static	int	exec_ssg_crm()
{
	char	*p;		/* p[^|C^ */
	int	dsp;		/* ʕ\L^ */
	int	prn;		/* v^o͗L^ */
	int	fil;		/* t@Co͗L^ */
	char	fname[SZ_PATH];	/* t@Co͗L莞̃t@C */

	/* ʕ\L^o */
	p = getprm();
	if ((dsp = getsel(p, ssg_crm1)) == -1)
		return(LOC_MSG_ERPRM);

	/* v^o͗L^o */
	p = getprm();
	if ((prn = getsel(p, ssg_crm2)) == -1)
		return(LOC_MSG_ERPRM);

	/* t@Co͗L^o */
	p = getprm();
	if ((fil = getsel(p, ssg_crm3)) == -1)
		return(LOC_MSG_ERPRM);

	/* t@Co͗L莞̃t@Co */
	p = getprm();
	if (strlen(p) > SZ_PATH)
		return(LOC_MSG_ERLEN);
	strcpy(fname, p);

	/* t@C̓`FbN */
	if (fil != 0) {
		if (*p == '\0')
			return(LOC_MSG_ERFILE);
	}

	/* gq`FbN */
	if (*p != '\0') {
		if ((p = strchr(p, '.')) == NULL)
			return(LOC_MSG_EREXT);
		if (fil == 1) {
			if (strcmp(p, ".MSL") != 0)
				return(LOC_MSG_EREXT);
		} else if (fil == 2) {
			if (strcmp(p, ".MSC") != 0)
				return(LOC_MSG_EREXT);
		}
	}

	/* p[^I`FbN */
	if (*cmbp != '/')
		return(LOC_MSG_ERPRM);

	/* VXerff[^Zbg */
	ssg.crm.dsp = dsp;
	ssg.crm.prn = prn;
	ssg.crm.fil = fil;
	strcpy(ssg.crm.fname, fname);

	/* VXerft@Cɏ */
	write_ssg();

	return(LOC_MSG_NORMAL);
}

/*=======================================================================
 |
 |		rrf@bleR}hs
 |
 |	int	exec_ssg_cmf()
 |
 =======================================================================*/
static	int	exec_ssg_cmf()
{
	char	*p;			/* p[^|C^ */
	char	cmd_path[SZ_PATH];	/* R}ht@Cǂ݂pX */

	/* R}ht@Cǂ݂pXo */
	p = getprm();
	if (strlen(p) > SZ_PATH)
		return(LOC_MSG_ERLEN);
	strcpy(cmd_path, p);

	/* p[^I`FbN */
	if (*cmbp != '/')
		return(LOC_MSG_ERPRM);

	/* VXerff[^Zbg */
	strcpy(ssg.cmf.cmd_path, cmd_path);

	/* VXerft@Cɏ */
	write_ssg();

	/* R}ht@C */
	find_cmf();

	return(LOC_MSG_NORMAL);
}

/*=======================================================================
 |
 |		rrf@`dbR}hs
 |
 |	int	exec_ssg_aec()
 |
 =======================================================================*/
static	int	exec_ssg_aec()
{
	char	*p;		/* p[^|C^ */
	int	i;		/* [vJE^ */
	char	aec[5][80];	/* 莞NR}h */

	for (i = 0; i < 5; i++) {
		p = getprm();
		strcpy(aec[i],p);
	}

	/* p[^I`FbN */
	if (*cmbp != '/')
		return(LOC_MSG_ERPRM);

	/* VXerff[^Zbg */
	for (i = 0; i < 5; i++)
		strcpy(ssg.aec[i].command, aec[i]);

	/* VXerft@Cɏ */
	write_ssg();

	return(LOC_MSG_NORMAL);
}

/*=======================================================================
 |
 |		cro@brfR}hs
 |
 |	int	exec_dsp_csg()
 |
 =======================================================================*/
static	int	exec_dsp_csg()
{
	int	i;		/* [vJE^ */
	CMD_TBL	*cmdp;		/* R}he[u|C^ */
	PRM_TBL	*prmp;		/* p[^ރe[u|C^ */

	/* p[^I`FbN */
	if (*cmbp != '/')
		return(LOC_MSG_ERPRM);

	/* R}he[u */
	for (cmdp = loctbl->ptr, i = 0; i < loctbl->n; i++, cmdp++) {
		if (strcmp(cmdp->name, "CSG") == 0)
			break;
	}
	if (i == loctbl->n)
		return(LOC_MSG_NORMAL);

	/* ݒl\ */
	for (prmp = cmdp->ptr, i = 0; i < cmdp->n; i++, prmp++) {
		if (strcmp(prmp->name, "NSG") == 0)
			exec_dsp_csg_nsg(prmp->ptr);
		else if (strcmp(prmp->name, "FSG") == 0)
			exec_dsp_csg_fsg(prmp->ptr);
		else if (strcmp(prmp->name, "COL") == 0)
			exec_dsp_csg_col(prmp->ptr);
		else if (strcmp(prmp->name, "LRM") == 0)
			exec_dsp_csg_lrm(prmp->ptr);
		else if (strcmp(prmp->name, "OPT") == 0)
			exec_dsp_csg_opt(prmp->ptr);
	}

	return(LOC_MSG_NORMAL);
}

/*=======================================================================
 |
 |		cro@brfCmrfR}hs
 |
 |	void	exec_dsp_csg_nsg(ptr)
 |
 |		PRT_TBL	*ptr;		p[^e[u|C^
 |
 =======================================================================*/
static	void	exec_dsp_csg_nsg(PRT_TBL *ptr)
{
	char	id[2];		/* R}hhc */

	enq_msg(MSG_CNS, "--- NSG ----------");
	dspnam(ptr++, csg.nsg.sys_name);
	dspnam(ptr++, csg.nsg.grf_file);
	id[0] = csg.nsg.online_id;
	id[1] = '\0';
	dspnam(ptr++, id);
	id[0] = csg.nsg.offline_id;
	dspnam(ptr, id);
}

/*=======================================================================
 |
 |		cro@brfCerfR}hs
 |
 |	void	exec_dsp_csg_fsg(ptr)
 |
 |		PRT_TBL	*ptr;		p[^e[u|C^
 |
 =======================================================================*/
static	void	exec_dsp_csg_fsg(PRT_TBL *ptr)
{
	int	i;		/* [vJE^ */

	enq_msg(MSG_CNS, "--- FSG ----------");
	dspnam(ptr++, csg.fsg.amsg_file);
	for (i= 0; i < 5; i++)
		dspnam(ptr++, csg.fsg.cms_file[i]);
	dspnam(ptr++, csg.fsg.cmsg_file);
	dspnam(ptr++, csg.fsg.loc_file);
	dspnam(ptr++, csg.fsg.lmsg_file);
}

/*=======================================================================
 |
 |		cro@brfCbnkR}hs
 |
 |	void	exec_dsp_csg_col(ptr)
 |
 |		PRT_TBL	*ptr;		p[^e[u|C^
 |
 =======================================================================*/
static	void	exec_dsp_csg_col(PRT_TBL *ptr)
{
	enq_msg(MSG_CNS, "--- COL ----------");
	dspsel(ptr++, csg_col[csg.col.c_waku]);
	dspsel(ptr++, csg_col[csg.col.c_offline]);
	dspsel(ptr++, csg_col[csg.col.c_online]);
	dspsel(ptr++, csg_col[csg.col.c_guide]);
	dspsel(ptr++, csg_col[csg.col.c_cnsmsg]);
	dspsel(ptr++, csg_col[csg.col.c_crm]);
	dspsel(ptr++, csg_col[csg.col.c_msga]);
	dspsel(ptr++, csg_col[csg.col.c_msgb]);
	dspsel(ptr, csg_col[csg.col.c_err]);
}

/*=======================================================================
 |
 |		cro@brfCkqlR}hs
 |
 |	void	exec_dsp_csg_lrm(ptr)
 |
 |		PRT_TBL	*ptr;		p[^e[u|C^
 |
 =======================================================================*/
static	void	exec_dsp_csg_lrm(PRT_TBL *ptr)
{
	enq_msg(MSG_CNS, "--- LRM ----------");
	dspsel(ptr++, csg_lrm1[csg.lrm.dsp]);
	dspsel(ptr++, csg_lrm2[csg.lrm.prn]);
	dspsel(ptr++, csg_lrm3[csg.lrm.fil]);
	dspnam(ptr, csg.lrm.fname);
}

/*=======================================================================
 |
 |		cro@brfCnosR}hs
 |
 |	void	exec_dsp_csg_opt(ptr)
 |
 |		PRT_TBL	*ptr;		p[^e[u|C^
 |
 =======================================================================*/
static	void	exec_dsp_csg_opt(PRT_TBL *ptr)
{
	enq_msg(MSG_CNS, "--- OPT ----------");
	dspsel(ptr++, csg_opt1[csg.opt.rs232c]);
	dspsel(ptr++, csg_opt2[csg.opt.printer]);
	dspnum(ptr++, csg.opt.cmd_to);
	dspsel(ptr++, csg_opt3[csg.opt.cmd_err]);
	dspsel(ptr, csg_opt4[csg.opt.comment]);
}

/*=======================================================================
 |
 |		cro@rrfR}hs
 |
 |	int	exec_dsp_ssg(ptr)
 |
 =======================================================================*/
static	int	exec_dsp_ssg()
{
	int	i;
	CMD_TBL	*cmdp;
	PRM_TBL	*prmp;

	/* p[^I`FbN */
	if (*cmbp != '/')
		return(LOC_MSG_ERPRM);

	/* R}he[u */
	for (cmdp = loctbl->ptr, i = 0; i < loctbl->n; i++, cmdp++) {
		if (strcmp(cmdp->name, "SSG") == 0)
			break;
	}
	if (i == loctbl->n)
		return(LOC_MSG_NORMAL);

	/* ݒl\ */
	for (prmp = cmdp->ptr, i = 0; i < cmdp->n; i++, prmp++) {
		if (strcmp(prmp->name, "NSG") == 0)
			exec_dsp_ssg_nsg(prmp->ptr);
		else if (strcmp(prmp->name, "SYC") == 0)
			exec_dsp_ssg_syc(prmp->ptr);
		else if (strcmp(prmp->name, "ANM") == 0)
			exec_dsp_ssg_anm(prmp->ptr);
		else if (strcmp(prmp->name, "CRM") == 0)
			exec_dsp_ssg_crm(prmp->ptr);
		else if (strcmp(prmp->name, "CMF") == 0)
			exec_dsp_ssg_cmf(prmp->ptr);
		else if (strcmp(prmp->name, "AEC") == 0)
			exec_dsp_ssg_aec(prmp->ptr);
	}

	return(LOC_MSG_NORMAL);
}

/*=======================================================================
 |
 |		cro@rrfCmrfR}hs
 |
 |	void	exec_dsp_ssg_nsg(ptr)
 |
 |		PRT_TBL	*ptr;		p[^e[u|C^
 |
 =======================================================================*/
static	void	exec_dsp_ssg_nsg(PRT_TBL *ptr)
{
	enq_msg(MSG_CNS, "--- NSG ----------");
	dspnam(ptr++, ssg.nsg.sys_name);
	dspnam(ptr++, ssg.nsg.grf_file);
	dspnum(ptr++, ssg.nsg.conxxxtion);
	if (ssg.nsg.kanshi != 0)
		dspnum(ptr, ssg.nsg.kanshi);
	else
		dspnam(ptr, "");
}

/*=======================================================================
 |
 |		cro@rrfCrxbR}hs
 |
 |	void	exec_dsp_ssg_syc(ptr)
 |
 |		PRT_TBL	*ptr;		p[^e[u|C^
 |
 =======================================================================*/
static	void	exec_dsp_ssg_syc(PRT_TBL *ptr)
{
	int	i;		/* [vJE^ */

	enq_msg(MSG_CNS, "--- SYC ----------");
	for (i = 0; i < 10; i++) {
		if (ssg.syc[i].syc_flg)
			dspnum(ptr++, ssg.syc[i].syc_val);
		else
			dspnam(ptr++, "");
	}
}

/*=======================================================================
 |
 |		cro@rrfC`mlR}hs
 |
 |	void	exec_dsp_ssg_anm(ptr)
 |
 |		PRT_TBL	*ptr;		p[^e[u|C^
 |
 =======================================================================*/
static	void	exec_dsp_ssg_anm(PRT_TBL *ptr)
{
	enq_msg(MSG_CNS, "--- ANM ----------");
	dspsel(ptr++, ssg_anm1[ssg.anm.dsp]);
	dspsel(ptr++, ssg_anm2[ssg.anm.prn]);
	dspsel(ptr++, ssg_anm3[ssg.anm.fil]);
	dspnam(ptr++, ssg.anm.fname);
}

/*=======================================================================
 |
 |		cro@rrfCbqlR}hs
 |
 |	void	exec_dsp_ssg_crm(ptr)
 |
 |		PRT_TBL	*ptr;		p[^e[u|C^
 |
 =======================================================================*/
static	void	exec_dsp_ssg_crm(PRT_TBL *ptr)
{
	enq_msg(MSG_CNS, "--- CRM ----------");
	dspsel(ptr++, ssg_crm1[ssg.crm.dsp]);
	dspsel(ptr++, ssg_crm2[ssg.crm.prn]);
	dspsel(ptr++, ssg_crm3[ssg.crm.fil]);
	dspnam(ptr, ssg.crm.fname);
}

/*=======================================================================
 |
 |		cro@rrfCbleR}hs
 |
 |	void	exec_dsp_ssg_cmf(ptr)
 |
 |		PRT_TBL	*ptr;		p[^e[u|C^
 |
 =======================================================================*/
static	void	exec_dsp_ssg_cmf(PRT_TBL *ptr)
{
	enq_msg(MSG_CNS, "--- CMF ----------");
	dspnam(ptr, ssg.cmf.cmd_path);
}

/*=======================================================================
 |
 |		cro@rrfC`dbR}hs
 |
 |	void	exec_dsp_ssg_aec(ptr)
 |
 |		PRT_TBL	*ptr;		p[^e[u|C^
 |
 =======================================================================*/
static	void	exec_dsp_ssg_aec(PRT_TBL *ptr)
{
	int	i;		/* [vJE^ */

	enq_msg(MSG_CNS, "--- AEC ----------");
	for (i = 0; i < 5; i++)
		dspnam(ptr++, ssg.aec[i].command);
}

/*=======================================================================
 |
 |		croR}hIڕ\
 |
 |	void	dspsel(ptr, sel)
 |
 |		PRT_TBL	*ptr;		p[^e[u|C^
 |		char	*sel;		I
 |
 =======================================================================*/
static	void	dspsel(PRT_TBL *ptr, char *sel)
{
	int	i;		/* [vJE^ */
	SEL_TBL	*seltp;		/* Iڃe[u|C^ */

	seltp = ptr->ptr.sel;
	for (i = 0; i < seltp->n; i++) {
		if (strcmp(sel, seltp->ptr[i][1]) == 0)
			break;
	}

	dspnam(ptr, i != seltp->n ? seltp->ptr[i][0] : "");
}

/*=======================================================================
 |
 |		croR}hlڕ\
 |
 |	void	dspnum(ptr, num)
 |
 |		PRT_TBL	*ptr;		p[^e[u|C^
 |		int	num;		l
 |
 =======================================================================*/
static	void	dspnum(PRT_TBL *ptr, int num)
{
	char	buf[80];	/* lҏWobt@ */

	sprintf(buf, "%u", num);
	dspnam(ptr, buf);
}

/*=======================================================================
 |
 |		croR}h̍ڕ\
 |
 |	void	dspnam(ptr, nam)
 |
 |		PRT_TBL	*ptr;		p[^e[u|C^
 |		char	*nam;		̍
 |
 =======================================================================*/
static	void	dspnam(PRT_TBL *ptr, char *nam)
{
	char	buf[80];	/* ҏWobt@ */
	char	*bp;		/* ҏWobt@|C^ */
	int	len;		/* ̒ */

	bp = buf;		/* obt@|C^Zbg */

	*bp++ = ' ';
	*bp++ = ' ';

	/* Zbg */
	strcpy(bp, ptr->guide);
	len = strlen(bp);
	bp += len;

	/* Xy[XZbg */
	while (len++ < 25)
		*bp++ = ' ';

	*bp++ = '[';
	*bp++ = ' ';

	/* f[^Zbg */
	strcpy(bp, nam);
	bp += strlen(bp);

	*bp++ = ' ';
	*bp++ = ']';
	*bp = '\0';

	enq_msg(MSG_CNS, buf);	/* bZ[W\ */
}

/*=======================================================================
 |
 |		brb@cnrR}hs
 |
 |	int	exec_csc_dos()
 |
 =======================================================================*/
static	int	exec_csc_dos()
{
	/* p[^I`FbN */
	if (*cmbp != '/')
		return(LOC_MSG_ERPRM);

	save_scr();		/* MʃZ[u */

	final();		/* I */
	spawnlp(0, "COMMAND", "COMMAND", 0L);	/* COMMAND.COM s */
	initialize();		/*  */

	restore_scr();		/* MʃXgA */

	if (online)
		rs_open();	/* qr|QRQbI[v */

	return(LOC_MSG_NORMAL);
}

/*=======================================================================
 |
 |		brb@bbpR}hs
 |
 |	int	exec_csc_ccq()
 |
 =======================================================================*/
static	int	exec_csc_ccq()
{
	/* p[^I`FbN */
	if (*cmbp != '/')
		return(LOC_MSG_ERPRM);

	if (online)
		disconxxxt();		/* RlNVؒf */

	return(LOC_MSG_NORMAL);
}

/*=======================================================================
 |
 |		brb@dmcR}hs
 |
 |	int	exec_csc_end()
 |
 =======================================================================*/
static	int	exec_csc_end()
{
	/* p[^I`FbN */
	if (*cmbp != '/')
		return(LOC_MSG_ERPRM);

	prog = 0;

	/* VXeIbZ[Wo */
	dsp_loc_msg(LOC_MSG_END, csg.nsg.sys_name);
	out_msg();

	return(LOC_MSG_NORMAL);
}

/*=======================================================================
 |
 |		tsk@boxR}hs
 |
 |	int	exec_utl_cpy()
 |
 =======================================================================*/
static	int	exec_utl_cpy()
{
	char	*p;			/* p[^|C^ */
	char	src_file[128];		/* Rs[t@C */
	char	dst_file[128];		/* Rs[t@C */
	char	cmd[128];		/* Rs[R}hҏWobt@ */

	/* Rs[Ώۃt@Co */
	p = getprm();
	if (*p == '\0')
		return(LOC_MSG_ERFILE);
	strcpy(src_file, p);

	/* Rs[pXt@Co */
	p = getprm();
	strcpy(dst_file, p);

	/* p[^I`FbN */
	if (*cmbp != '/')
		return(LOC_MSG_ERPRM);

	/* COPY R}hҏW */
	sprintf(cmd, "COPY %s %s", src_file, dst_file);

	save_scr();		/* MʃZ[u */
	final();		/* I */
	system(cmd);		/* COPY R}hs */
	printf("\nǂꂩL[ĉB");
	getch();
	initialize();		/*  */
	restore_scr();		/* MʃXgA */
	if (online)
		rs_open();	/* qr|QRQbI[v */

	return(LOC_MSG_NORMAL);
}

/*=======================================================================
 |
 |		tsk@befR}hs
 |
 |	int	exec_utl_cfg()
 |
 =======================================================================*/
static	int	exec_utl_cfg()
{
	char	*p;		/* p[^|C^ */

	/* R}ht@Co */
	p = getprm();
	if (*p == '\0')
		return(LOC_MSG_ERFILE);
	strcpy(cmf_name, p);

	/* @\Tvo */
	p = getprm();
	strcpy(cmf_guide, p);

	/* p[^I`FbN */
	if (*cmbp != '/')
		return(LOC_MSG_ERPRM);

	/* R}ht@C쐬Gʍ쐬 */
	memset(cfg_grf, 0, sizeof(cfg_grf));
	grfputs(4, 3, "R}ḩ", C_BLUE, cfg_grf);
	grfputs(4, 6, cmf_name, C_YELLOW, cfg_grf);
	grfputs(20, 10, "쐬", C_BLUE, cfg_grf);

	save_scr();	/* ݂̎MʃZ[u */
	mkcmd = 1;	/* R}ht@C쐬tOZbg */
	exec_prog(2);	/* eN */
	mkcmd = 0;	/* R}h쐬tOZbg */
	local = 1;	/* [JtOZbg */
	find_cmf();	/* R}ht@C */
	restore_scr();	/* MʃXgA */

	prog = 7;

	return(LOC_MSG_NORMAL);
}

/*=======================================================================
 |
 |		tsk@becR}hs
 |
 |	int	exec_utl_cfd()
 |
 =======================================================================*/
static	int	exec_utl_cfd()
{
	char	*p;		/* p[^|C^ */
	int	ps;		/* I */

	/* Io */
	p = getprm();
	if ((ps = getsel(p, utl_cfd)) == -1)
		return(LOC_MSG_ERPRM);

	/* R}ht@Co */
	p = getprm();
	if (*p == '\0')
		return(LOC_MSG_ERFILE);
	strcpy(cmf_name, p);

	/* p[^I`FbN */
	if (*cmbp != '/')
		return(LOC_MSG_ERPRM);

	if (access(cmf_name, 0) != 0)
		return(LOC_MSG_ERNOFILE);

	switch (ps) {
	case 0:		/* \ */
		read_cmf();	/* R}ht@Cǂݍ */
		save_scr();	/* ݂̎MʃZ[u */
		prog6c();	/* R}ht@Ce\ʏ */
		restore_scr();	/* MʃXgA */
		break;
	case 1:		/* C */
		/* R}ht@CCGʍ쐬 */
		memset(cfg_grf, 0, sizeof(cfg_grf));
		grfputs(4, 3, "R}ḩ", C_BLUE, cfg_grf);
		grfputs(4, 6, cmf_name, C_YELLOW, cfg_grf);
		grfputs(20, 10, "C", C_BLUE, cfg_grf);

		read_cmf();	/* R}ht@Cǂݍ */
		save_scr();	/* ݂̎MʃZ[u */
		mkcmd = 2;	/* R}ht@C쐬tOZbg */
		exec_prog(6);	/* eN */
		mkcmd = 0;	/* R}h쐬tOZbg */
		local = 1;	/* [JtOZbg */
		find_cmf();	/* R}ht@C */
		restore_scr();	/* MʃXgA */
		prog = 7;
		break;
	case 2:		/* 폜 */
		remove(cmf_name);	/* R}ht@C폜 */
		find_cmf();		/* R}ht@C */
		break;
	}

	return(LOC_MSG_NORMAL);
}

/*=======================================================================
 |
 |		tsk@lsqR}hs
 |
 |	int	exec_utl_mtr()
 |
 =======================================================================*/
static	int	exec_utl_mtr()
{
	char	*p;			/* p[^|C^ */
	char	ifname[SZ_PATH];	/* ϊOt@C */
	int	kind;			/* bZ[W */
	int	dsp;			/* ʕ\L^ */
	int	prn;			/* v^o͗L^ */
	int	fil;			/* t@Co͗L^ */
	char	ofname[SZ_PATH];	/* ϊt@C */
	FILE	*ifp, *ofp;		/* t@C|C^ */
	char	buf[512];		/* t@Cǂݍ݃obt@ */
	char	*msg;			/* ϊチbZ[W|C^ */
	int	class;			/* bZ[WNX */

	/* bZ[Wގo */
	p = getprm();
	if ((kind = getsel(p, utl_mtr1)) == -1)
		return(LOC_MSG_ERPRM);

	/* ϊOt@Co */
	p = getprm();
	if (strlen(p) > SZ_PATH)
		return(LOC_MSG_ERPRM);
	strcpy(ifname, p);

	/* t@C̓`FbN */
	if (*p == '\0')
		return(LOC_MSG_ERFILE);

	/* ʕ\L^o */
	p = getprm();
	if ((dsp = getsel(p, utl_mtr2)) == -1)
		return(LOC_MSG_ERPRM);

	/* v^o͗L^o */
	p = getprm();
	if ((prn = getsel(p, utl_mtr3)) == -1)
		return(LOC_MSG_ERPRM);

	/* t@Co͗L^o */
	p = getprm();
	if ((fil = getsel(p, utl_mtr4)) == -1)
		return(LOC_MSG_ERPRM);

	/* ϊt@Co */
	p = getprm();
	if (strlen(p) > SZ_PATH)
		return(LOC_MSG_ERLEN);
	strcpy(ofname, p);

	/* t@C̓`FbN */
	if (fil != 0) {
		if (*p == '\0')
			return(LOC_MSG_ERFILE);
	}

	/* gq`FbN */
	if (*p != '\0') {
		if ((p = strchr(p, '.')) == NULL || strcmp(p, ".MSL") != 0)
			return(LOC_MSG_EREXT);
	}

	/* ϊOt@CI[v */
	if ((ifp = fopen(ifname, "r")) == NULL)
		return(LOC_MSG_ERNOFILE);

	/* ϊt@CI[v */
	if (fil != 0) {
		if ((ofp = fopen(ofname, "w")) == NULL)
			fil = 0;
	}

	out_msg();

	/* bZ[Wo */
	while (fgets(buf, sizeof(buf), ifp) != NULL) {
		buf[strlen(buf) - 1] = '\0';
		msg = buf;
		if (strncmp(msg, "@MSG", 4) == 0)
			msg = cnv_msg(msg + 4, kind == 0 ? anm_msg : crm_msg, &class);
		if (dsp)
			dsp_msg(msg, C_CNSMSG);
		if (prn)
			lprintf("%s\x0d\x0a", msg);
		if (fil)
			fprintf(ofp, "%s\n", msg);
	}

	/* t@CN[Y */
	fclose(ifp);
	if (fil != 0)
		fclose(ofp);

	/* p[^I`FbN */
	if (*cmbp != '/')
		return(LOC_MSG_ERPRM);


	return(LOC_MSG_NORMAL);
}

/*=======================================================================
 |
 |		Iڎo
 |
 |	int	getsel(p, prm)
 |
 |		char	*p;		I
 |		char	**prm;		Iڃe[u
 |
 =======================================================================*/
static	int	getsel(char *p, char **prm)
{
	int	i;		/* [vJE^ */

	/* Iڌ */
	for (i = 0; prm[i] != NULL; i++) {
		if (strcmp(p, prm[i]) == 0)
			return(i);
	}
	return(-1);
}

/*=======================================================================
 |
 |		p[^o
 |
 |	char	*getprm()
 |
 =======================================================================*/
static	char	*getprm()
{
	static	char	prmbuf[80];	/* p[^oobt@ */
	int	i;		/* [vJE^ */
	int	c;

	if (*cmbp == ',') {
		for (i = 0; i < sizeof(prmbuf); i++) {
			c = *++cmbp;
			if (c == ',' || c == '/' || c == '\0')
				break;
			prmbuf[i] = c;
		}
		prmbuf[i] = '\0';
	} else
		prmbuf[0] = '\0';

	return(prmbuf);
}

/*=======================================================================
 |
 |		[JR}hҏW
 |
 |	void	edit_loc_cmd()
 |
 =======================================================================*/
void	edit_loc_cmd()
{
	int	i;		/* [vJE^ */

	cmbp = cmdbuf;
	switch (chk_loc_cmd()) {
	case LOC_CSG_NSG:
		setnam(csg.nsg.sys_name);
		setnam(csg.nsg.grf_file);
		*cmbp++ = ',';
		*cmbp++ = csg.nsg.online_id;
		*cmbp++ = ',';
		*cmbp++ = csg.nsg.offline_id;
		break;
	case LOC_CSG_FSG:
		setnam(csg.fsg.amsg_file);
		for (i= 0; i < 5; i++)
			setnam(csg.fsg.cms_file[i]);
		setnam(csg.fsg.cmsg_file);
		setnam(csg.fsg.loc_file);
		setnam(csg.fsg.lmsg_file);
		break;
	case LOC_CSG_COL:
		setsel(csg_col[csg.col.c_waku]);
		setsel(csg_col[csg.col.c_offline]);
		setsel(csg_col[csg.col.c_online]);
		setsel(csg_col[csg.col.c_guide]);
		setsel(csg_col[csg.col.c_cnsmsg]);
		setsel(csg_col[csg.col.c_crm]);
		setsel(csg_col[csg.col.c_msga]);
		setsel(csg_col[csg.col.c_msgb]);
		setsel(csg_col[csg.col.c_err]);
		break;
	case LOC_CSG_LRM:
		setsel(csg_lrm1[csg.lrm.dsp]);
		setsel(csg_lrm2[csg.lrm.prn]);
		setsel(csg_lrm3[csg.lrm.fil]);
		setnam(csg.lrm.fname);
		break;
	case LOC_CSG_OPT:
		setsel(csg_opt1[csg.opt.rs232c]);
		setsel(csg_opt2[csg.opt.printer]);
		setnum(csg.opt.cmd_to);
		setsel(csg_opt3[csg.opt.cmd_err]);
		setsel(csg_opt4[csg.opt.comment]);
		break;
	case LOC_SSG_NSG:
		setnam(ssg.nsg.sys_name);
		setnam(ssg.nsg.grf_file);
		setnum(ssg.nsg.conxxxtion);
		if (ssg.nsg.kanshi != 0)
			setnum(ssg.nsg.kanshi);
		else
			*cmbp++ = ',';
		break;
	case LOC_SSG_SYC:
		for (i = 0; i < 10; i++) {
			if (ssg.syc[i].syc_flg)
				setnum(ssg.syc[i].syc_val);
			else
				*cmbp++ = ',';
		}
		break;
	case LOC_SSG_ANM:
		setsel(ssg_anm1[ssg.anm.dsp]);
		setsel(ssg_anm2[ssg.anm.prn]);
		setsel(ssg_anm3[ssg.anm.fil]);
		setnam(ssg.anm.fname);
		break;
	case LOC_SSG_CRM:
		setsel(ssg_crm1[ssg.crm.dsp]);
		setsel(ssg_crm2[ssg.crm.prn]);
		setsel(ssg_crm3[ssg.crm.fil]);
		setnam(ssg.crm.fname);
		break;
	case LOC_SSG_CMF:
		setnam(ssg.cmf.cmd_path);
		break;
	case LOC_SSG_AEC:
		for (i = 0; i < 5; i++)
			setnam(ssg.aec[i].command);
		break;
	}
	*cmbp = '\0';
}

/*=======================================================================
 |
 |		IڃZbg
 |
 |	void	setsel(data)
 |
 |		char	*data;		I
 |
 =======================================================================*/
static	void	setsel(char *data)
{
	*cmbp++ = ',';
	strcpy(cmbp, data);

	cmbp += strlen(cmbp);
}

/*=======================================================================
 |
 |		lڃZbg
 |
 |	void	setnum(data)
 |
 |		int	data;		l
 |
 =======================================================================*/
static	void	setnum(int data)
{
	*cmbp++ = ',';
	sprintf(cmbp, "%u", data);

	cmbp += strlen(cmbp);
}

/*=======================================================================
 |
 |		̍ڃZbg
 |
 |	void	setnam(data)
 |
 |		char	*data;		̍
 |
 =======================================================================*/
static	void	setnam(char *data)
{
	*cmbp++ = ',';
	strcpy(cmbp, data);

	cmbp += strlen(cmbp);
}

/*=======================================================================
 |
 |		[JR}h`FbN
 |
 |	int	chk_loc_cmd()
 |
 |		int	data;		l
 |
 =======================================================================*/
static	int	chk_loc_cmd()
{
	struct	prm	{
		char	prm[4];
		int	code;
	};
	static	struct	prm	csg_prm[] = {
		{"NSG", LOC_CSG_NSG},
		{"FSG", LOC_CSG_FSG},
		{"COL", LOC_CSG_COL},
		{"LRM", LOC_CSG_LRM},
		{"OPT", LOC_CSG_OPT},
		{"", 0}
	};
	static	struct	prm	ssg_prm[] = {
		{"CON", LOC_SSG_CON},
		{"NSG", LOC_SSG_NSG},
		{"SYC", LOC_SSG_SYC},
		{"ANM", LOC_SSG_ANM},
		{"CRM", LOC_SSG_CRM},
		{"CMF", LOC_SSG_CMF},
		{"AEC", LOC_SSG_AEC},
		{"", 0}
	};
	static	struct	prm	dsp_prm[] = {
		{"CSG",	LOC_DSP_CSG},
		{"SSG",	LOC_DSP_SSG},
		{"", 0}
	};
	static	struct	prm	csc_prm[] = {
		{"CCQ", LOC_CSC_CCQ},
		{"DOS", LOC_CSC_DOS},
		{"END", LOC_CSC_END},
		{"", 0}
	};
	static	struct	prm	utl_prm[] = {
		{"CPY", LOC_UTL_CPY},
		{"CFG", LOC_UTL_CFG},
		{"CFD", LOC_UTL_CFD},
		{"MTR", LOC_UTL_MTR},
		{"", 0}
	};
	static	struct	{
		char	cmd[4];
		int	code;
		struct	prm	*prm;
	} cmd[] = {
		{"CSG",	LOC_CSG, csg_prm},
		{"SSG", LOC_SSG, ssg_prm},
		{"DSP", LOC_DSP, dsp_prm},
		{"CSC", LOC_CSC, csc_prm},
		{"UTL", LOC_UTL, utl_prm},
		{"", 0, NULL}
	};
	int	i;		/* [vJE^ */
	int	code;		/* R}hR[h */
	struct	prm	*prm;

	/* R}ho */
	for (i = 0, cmbp++; i < 3 && *cmbp != '\0'; i++, cmbp++)
		cmd_name[i] = *cmbp;
	cmd_name[i] = '\0';

	/* p[^o */
	while (*cmbp == ' ')
		cmbp++;
	for (i = 0; i < 3 && *cmbp != '\0'; i++, cmbp++)
		prm_name[i] = *cmbp;
	prm_name[i] = '\0';

	/* R}h`FbN */
	for (i = 0; cmd[i].code; i++) {
		if (strcmp(cmd_name, cmd[i].cmd) == 0)
			break;
	}

	/* p[^`FbN */
	if (cmd[i].code) {
		prm = cmd[i].prm;
		for (i = 0; prm[i].code; i++) {
			if (strcmp(prm_name, prm[i].prm) == 0)
				break;
		}
		code = prm[i].code;
	} else
		code = 0;

	return(code);
}
